// strprint.h
// Glenn G. Chappell
// 15 Oct 2013
//
// For CS 202 Fall 2013
// Header for class StrPrint
// Sample Base Class

#ifndef FILE_STRPRINT_H_INCLUDED
#define FILE_STRPRINT_H_INCLUDED

#include <string>
using std::string;
#include <iostream>
using std::ostream;
using std::cout;


class StrPrint {

// ***** StrPrint: ctors, dctor, op= *****
public:

    // Ctor from string, default ctor
    // Set string member to given string, or "" if not given.
    StrPrint(const string & s="")
    {
        setString(s);
    }

    // Dctor
    // Virtual, so we can use this as a base class.
    virtual ~StrPrint()
    {}

    // Compiler-generated copy ctor, op= used

// ***** StrPrint: general public functions *****
public:

    // out (virtual)
    // Print our string member.
    virtual void out(ostream & os=cout) const;

    // Get & set functions for our string
    string getString() const
    {
        return _s;
    }
    void setString(const string & s)
    {
        _s = s;
    }

// ***** StrPrint: data members *****
private:

    string _s;  // Our string to print
};

#endif //#ifndef FILE_STRPRINT_H_INCLUDED

